// $Id: editview.js,v 1.1.2.1 2006/10/30 05:58:10 wrunt Exp $

/******************************************************************

  This file is part of Editview.

  Editview is free software; you can redistribute it and/or modify it under the
  terms of the GNU General Public License as published by the Free Software
  Foundation; either version 2.1 of the License, or (at your option) any later
  version.

  Editview is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  Editview; if not, write to the Free Software Foundation, Inc., 59 Temple
  Place, Suite 330, Boston, MA  02111-1307  USA

  Editview
  Copyright (C) 2006 Agileware Pty Ltd
  Unit 17/160 Lysaght St. MITCHELL 2911 Canberra Australia
  web http://www.agileware.net/
  email enquiry@agileware.net

 *******************************************************************/

if (isJsEnabled()) {
  addLoadEvent(editviewAutoAttach);
}

function editviewAutoAttach() {
  var forms = document.getElementsByTagName('form');
  for (i = 0; form = forms[i]; i++) {
    if (form && form.elements['edit[form_id]']) {
      var inputs = form.getElementsByTagName('input');
      for (j = 0; input = inputs[j]; j++) {
        if (input && (input.getAttribute('name') == 'op') && (input.getAttribute('type') == 'submit')) {
          var buttonId = input.getAttribute('id');
          var uri = $('editview-submit-url').innerHTML;
          if (hasClass(input, 'editview-button')) {
            var nid = form.elements['edit[form_id]'].value.replace(/editview_node_form_/, '');
            if (nid) {
              var wrapperId = 'editview-' + nid + '-wrapper';
            } else {
              // we are creating a new node. reload the whole view.
              var vid = form.elements['edit[view_id]'].value;
              var wrapperId = 'editview-view-' + vid + '-wrapper';
            }
            new editview(uri, nid, buttonId, wrapperId);
          }
          if (hasClass(input, 'editview-delete-button')) {
            var nid = form.elements['edit[form_id]'].value.replace(/editview_delete_/, '');
            var wrapperId = 'editview-delete-' + nid + '-wrapper';
            new editview(uri, nid, buttonId, wrapperId);
          }
        }
      }
    }
  }
}

// create a new editview
function editview(uri, nid, buttonId, wrapperId) {
  this.uri = uri;
  this.buttonId = buttonId;
  this.wrapperId = wrapperId;
  editviewRedirectFormButton(uri, $(buttonId), this);
}

editview.prototype.onsubmit = function() {
  var wrapper = $(this.wrapperId);
  this.progress = new progressBar('editviewprogress');
  this.progress.setProgress(-1, 'Updating...');
  this.progress.element.style.width = wrapper.style.width;
  this.progress.element.style.height = wrapper.style.height;
  wrapper.parentNode.insertBefore(this.progress.element, wrapper);
  editviewHide(wrapper);
}

editview.prototype.oncomplete = function(data) {
  var wrapper = $(this.wrapperId);

  // hide the progress bar
  removeNode(this.progress.element);
  this.progress = null;

  // report back drupal messages
  message = $('editview_messages');
  if (data['message']) {
    message.innerHTML = data['message'];
    message.style.display = 'block';
  } else {
    message.style.display = 'none';
  }

  // apply changes and unhide
  //wrapper.innerHTML = data['form'];
  editviewReplace(wrapper, data['form']);
  editviewShow(wrapper);

  editviewAutoAttach();
  //window.onload(); // causes problems in IE
}

function editviewReplace(node, data) {
  var replacement = document.createElement("span");
  replacement.innerHTML = data;
  node.parentNode.replaceChild(replacement, node);
}

editview.prototype.onerror = function(error) {
  alert('An error occurred:\n\n' + error);
  removeNode(this.progress.element);
  this.progress = null;
  editviewShow($(this.wrapperId));
}

function editviewHide(element) {
  //element.style.position = 'absolute';
  //element.style.left = '-2000px';
  element.style.display = 'none';
}

function editviewShow(element) {
  //element.style.position = 'static';
  //element.style.left = '0px';
  element.style.display = 'block';
}

/* replacement for drupal.js' redirectFormButton. this makes pressing enter
 * submit the form as well as clicking the submit button. */
function editviewRedirectFormButton(uri, button, handler) {
  // (Re)create an iframe to target.
  createIframe();

  // Trap the button
  button.onmouseover = button.onfocus = function() {
    // disable form's onsubmit so we don't run this code twice
    button.form.onsubmit = null;

    button.onclick = function() {
      // Prepare variables for use in anonymous function.
      var button = this;

      // Redirect form submission
      this.form.action = uri;
      this.form.target = 'redirect-target';

      handler.onsubmit();

      // Set iframe handler for later
      window.iframeHandler = function () {
        var iframe = $('redirect-target');

        // Get response from iframe body
        try {
          response = (iframe.contentWindow || iframe.contentDocument || iframe).document.body.innerHTML;   
          // Firefox 1.0.x hack: Remove (corrupted) control characters
          response = response.replace(/[\f\n\r\t]/g, ' ');
          if (window.opera) {
            // Opera-hack: it returns innerHTML sanitized.
            response = response.replace(/&quot;/g, '"');
          }
        }
        catch (e) {
          response = null;
        }

        $('redirect-target').onload = null;
        $('redirect-target').src = 'about:blank';

        response = parseJson(response);
        // Check response code
        if (response.status == 0) {
          handler.onerror(response.data);
          return;
        }
        handler.oncomplete(response.data);
      }

      return true;
    }
  }

  var enterSubmit = function() {
    var form = this;

    form.action = uri;
    form.target = 'redirect-target';

    handler.onsubmit();

    // Set iframe handler for later
    window.iframeHandler = function () {
      var iframe = $('redirect-target');

      // Get response from iframe body
      try {
        response = (iframe.contentWindow || iframe.contentDocument || iframe).document.body.innerHTML;   
        // Firefox 1.0.x hack: Remove (corrupted) control characters
        response = response.replace(/[\f\n\r\t]/g, ' ');
        if (window.opera) {
          // Opera-hack: it returns innerHTML sanitized.
          response = response.replace(/&quot;/g, '"');
        }
      }
      catch (e) {
        response = null;
      }

      $('redirect-target').onload = null;
      $('redirect-target').src = 'about:blank';

      response = parseJson(response);
      // Check response code
      if (response.status == 0) {
        handler.onerror(response.data);
        return;
      }
      handler.oncomplete(response.data);
    }

    return true;
  }

  button.form.onsubmit = enterSubmit;
  button.form.action = uri;
  button.form.target = 'redirect-target';

  button.onmouseout = button.onblur = function() {
    button.onclick = null;
    button.form.onsubmit = enterSubmit;
  }
}

